﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PT.Scheduler;
using PT.Scheduler.Simulation;
using PT.Scheduler.Simulation.Customizations;

namespace Planettogether.Sample.CampaignPostProcessing
{
    public class RequiredCapacityCust : PT.Scheduler.Simulation.Customizations.RequiredCapacityCustomization
    {
        public override string Name => "AddCampaignPostProcessing";

        public override string Description => "Add post processing.";

        Dictionary<BaseId, TimeSpan> m_activityPostProcessing = new Dictionary<BaseId, TimeSpan>();

        protected override void AfterRequiredCapacityCalculation(BaseActivity a_activity, BaseResource a_resource, RequiredCapacityChangeHelper a_rc, long a_startTicks)
        {
            base.AfterRequiredCapacityCalculation(a_activity, a_resource, a_rc, a_startTicks);

            if (m_activityPostProcessing.TryGetValue(a_activity.Id, out TimeSpan postProcessing))
            {
                a_rc.RequiredCapacityChanger.PostProcessingSpan = new RequiredSpan(postProcessing.Ticks, false);
            }
        }

        internal void SetActivityPostProcessing(Dictionary<BaseId, TimeSpan> a_activityPostProcessing)
        {
            m_activityPostProcessing = a_activityPostProcessing;
        }
    }
}
